import React from 'react';
import PropTypes from 'prop-types';
import { generateColClassName, generateFlexClassNames } from '../../util/className';

/**
 * @class Col
 */
class Col extends React.Component
{
	static propTypes = {
		xs: PropTypes.number,
		xsOffset: PropTypes.number,
		sm: PropTypes.number,
		smOffset: PropTypes.number,
		md: PropTypes.number,
		mdOffset: PropTypes.number,
		lg: PropTypes.number,
		lgOffset: PropTypes.number,
		first: PropTypes.arrayOf(
			PropTypes.string
		),
		last: PropTypes.arrayOf(
			PropTypes.string
		),
		children: PropTypes.node
	};

	/**
	 * Lifecycle method
	 * Will Component Mounted
	 * @return {void}
	 */
	componentWillMount()
	{
		this.class = `
		${ this.props.xs ?
			generateColClassName( 'xs', this.props.xs ) :
			"" }
		${ this.props.xsOffset ?
			generateColClassName( 'xs-offset', this.props.xsOffset ) :
			"" }
		${ this.props.sm ?
			generateColClassName( 'sm', this.props.sm ) :
			"" }
		${ this.props.smOffset ?
			generateColClassName( 'sm-offset', this.props.smOffset ) :
			"" }
		${ this.props.md ?
			generateColClassName( 'md', this.props.md ) :
			"" }
		${ this.props.mdOffset ?
			generateColClassName( 'md-offset', this.props.mdOffset ) :
			"" }
		${ this.props.lg ?
			generateColClassName( 'lg', this.props.lg ) :
			"" }
		${ this.props.lgOffset ?
			generateColClassName( 'lg-offset', this.props.lgOffset ) :
			"" }
		${ this.props.last ?
			generateFlexClassNames( 'last', this.props.last ) :
			"" }
		${ this.props.first ?
			generateFlexClassNames( 'first', this.props.first ) :
			"" }
		`;
	}

	/**
	 * @constructor
	 */
	constructor()
	{
		super();
	}

	/**
	 * Render Component
	 * @return {XML} xml
	 */
	render()
	{
		return (
			<div className={ this.class }>
				{ this.props.children }
			</div>
		);
	}
}

export default Col;