import React from 'react';
import { generateFlexClassNames } from '../../util/className';
import PropTypes from 'prop-types';

/**
 * @class Flex
 */
class Flex extends React.Component
{

	static propTypes = {
		reverse: PropTypes.bool,
		start: PropTypes.arrayOf(
			PropTypes.string
		),
		center: PropTypes.arrayOf(
			PropTypes.string
		),
		end: PropTypes.arrayOf(
			PropTypes.string
		),
		top: PropTypes.arrayOf(
			PropTypes.string
		),
		middle: PropTypes.arrayOf(
			PropTypes.string
		),
		bottom: PropTypes.arrayOf(
			PropTypes.string
		),
		around: PropTypes.arrayOf(
			PropTypes.string
		),
		between: PropTypes.arrayOf(
			PropTypes.string
		),
		children: PropTypes.node
	};

	/**
	 * @constructor
	 */
	constructor()
	{
		super();
	}

	/**
	 * Lifecycle method
	 * Will Component Mounted
	 * @return {void}
	 */
	componentWillMount()
	{
		this.class = `
		${ this.props.reverse ?
			"reverse" :
			"" }
		${ this.props.start ? 
			generateFlexClassNames( 'start', this.props.start ) : 
			"" }
		${ this.props.center ?
			generateFlexClassNames( 'center', this.props.center ) :
			"" }
		${ this.props.end ?
			generateFlexClassNames( 'end', this.props.end ) :
			"" }
		${ this.props.top ?
			generateFlexClassNames( 'top', this.props.top ) :
			"" }
		${ this.props.middle ?
			generateFlexClassNames( 'middle', this.props.middle ) :
			"" }
		${ this.props.bottom ?
			generateFlexClassNames( 'bottom', this.props.bottom ) :
			"" }
		${ this.props.around ?
			generateFlexClassNames( 'around', this.props.around ) :
			"" }
		${ this.props.between ?
			generateFlexClassNames( 'between', this.props.between ) :
			"" }
		`;
	}

	/**
	 * Render Component
	 * @return {XML} xml
	 */
	render()
	{
		return (
			<div className={ `row ${ this.class }` }>
				{ this.props.children }
			</div>
		);
	}
}

export default Flex;