const webpack = require( 'webpack' );
const WebpackStrip = require( 'strip-loader' );

// main config file
const config = require( './webpack.config' );

// output path
config.output.path = './public/';

// cdn path
config.output.publicPath = '/front-end-service/';

config.plugins.push(
	new webpack.DefinePlugin( {
		'process.env':
		{
			NODE_ENV: JSON.stringify( 'production' )
		}
	} )
);

config.module.loaders.push( {
	test: /\.js$/,
	loader: WebpackStrip.loader( 'console.log' )
} );

module.exports = config;